\\ Copyright 2019 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0);
default(strictargs,1);

option_verbose=0;

read("../vpar.gp");
read("../test-helpers.gp");


perm_is_231_avoiding(perm) =
{
  for(i=1,#perm-2,                 \\ i=2
     for(j=i+1,#perm-1,
        if(perm[j]>perm[i],        \\ j=3 bigger than 2
           for(k=j+1,#perm,
              if(perm[k]<perm[i],  \\ k=1 smaller than 2
                 return(0))))));
  1;           
}

perm_is_312_avoiding(perm) =
{
  for(i=1,#perm-2,                 \\ i=3
     for(j=i+1,#perm-1,
        if(perm[j]<perm[i],        \\ j=1, smaller than 3
           for(k=j+1,#perm,
              if(perm[k]<perm[i] && perm[k]>perm[j],  \\ k=2 between 3 and 1
                 return(0))))));
  1;           
}

{
  for(n=1,6,
     print(sum(i=1,n!, perm_is_231_avoiding(numtoperm(n,i)))));
}
{
  for(n=1,6,
     print(sum(i=1,n!, perm_is_312_avoiding(numtoperm(n,i)))));
}


{
  \\ post=inorder -> diagpost
  for(n=1,10,
     my(vpar=vpar_preorder_first(n),
        m=Map());
     until((vpar=vpar_preorder_next(vpar,1))=='none,  \\ forests
           my(vpar=vpar_relabel_postorder(vpar),
              seq=vpar_seq_diagpost(vpar));
           check_equal(perm_is_312_avoiding(seq), 1);
           check_equal(perm_is_231_avoiding(seq^-1), 1);
           mapput(m,seq,1);
          );
     check_equal(#m,vpar_count_ordered(n,1)));
}
{
  \\ preorder -> post=inorder
  for(n=1,10,
     my(vpar=vpar_preorder_first(n),
        m=Map());
     until((vpar=vpar_preorder_next(vpar,1))=='none,  \\ forests
           my(seq=vpar_seq_postorder(vpar));
           check_equal(perm_is_312_avoiding(seq), 1);
           check_equal(perm_is_231_avoiding(seq^-1), 1);
           mapput(m,seq,1);
          );
     check_equal(#m,vpar_count_ordered(n,1)));
}