\\ Copyright 2021 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(parisizemax,500*10^6);
default(recover,0);
default(strictargs,1);
read("a347620-Matula-inverse.gp");

{
  my(len=1 000 000, reps=1);
  my(u,v);
  gettime(); for(i=1,reps, v=num_vertices_vector_by_forfactored(len)); print("forfactored first ",gettime());
  gettime(); for(i=1,reps, v=num_vertices_vector_by_forfactored(len)); print("forfactored ",gettime());
  gettime(); for(i=1,reps, v=num_vertices_vector_by_forfactored(len)); print("forfactored ",gettime());
  gettime(); for(i=1,reps, u=num_vertices_vector               (len)); print("forprime    first ",gettime());
  gettime(); for(i=1,reps, u=num_vertices_vector               (len)); print("forprime    ",gettime());
  gettime(); for(i=1,reps, u=num_vertices_vector               (len)); print("forprime    ",gettime());
  u==v || error();
}

\\ Local variables:
\\ compile-command: "gp -f --quiet <a347620-Matula-inverse-speed.gp"
\\ End: