\\ Copyright 2017, 2018 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0)
default(strictargs,1)
default(parisizemax,500*10^6);
read("../vpar.gp");
read("../vpar-wip.gp");
setrand(getwalltime()%2^32);


check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong: "name);
     print("got  "got);
     print("want "want);
     quit(1),
     option_verbose,
     print("ok "check_count" "name));
}


\\------------------------------------------------------------------------------
\\ vpar_domnum_sets()
\\
\\ no disjoint pair of minimum dominating sets,
\\ even though no single vertex common to all

\\ n=16 domnum 6 count 18
\\ [0, 1, 2, 3, 4, 5, 6, 7, 8, 6, 10, 5, 12, 13, 4, 15]
\\ vpar_view(vpar_reroot([0,1,2,3,4,5,6,7,8,6,10,5,12,13,4,15],5))
\\
\\             *
\\          /  |  \
\\        *    *    *
\\      / |    |    | \
\\     *  *    *    *  *
\\     |  |    |    |  |
\\     *  *    *    *  *
\\     |               |
\\     *               *
\\
\\ n=18 domnum 7 count 36
\\   vpar_view(vpar_reroot(  [0, 1, 2, 3, 4, 5, 4, 2, 8, 1, 10, 11, 12, 10, 14, 1, 16, 17],  1))
\\ n=18 domnum 7 count 36
\\   vpar_view(vpar_reroot(  [0, 1, 2, 3, 4, 3, 2, 7, 8, 1, 10, 11, 12, 10, 14, 1, 16, 17], 1))
\\ n=18 domnum 7 count 36
\\   vpar_view(vpar_reroot(  [0, 1, 2, 3, 4, 3, 1, 7, 8, 9, 7, 11, 1, 13, 14, 15, 13, 17], 1))
\\ n=18 domnum 7 count 42
\\   vpar_view(vpar_reroot(  [0, 1, 2, 3, 4, 2, 6, 2, 8, 1, 10, 11, 12, 10, 14, 1, 16, 17], 1))
\\
\\ n=19   10 of
\\ n=19 domnum 7 count 20
\\ vpar_view(vpar_reroot(  [0, 1, 2, 3, 4, 5, 6, 4, 8, 3, 10, 11, 2, 13, 1, 15, 16, 17, 18], 3))
\\ n=19 domnum 7 count 25
\\ vpar_view(vpar_reroot(    [0, 1, 2, 3, 4, 5, 6, 4, 8, 3, 10, 11, 1, 13, 14, 15, 16, 14, 18], 3))
\\ n=19 domnum 7 count 25
\\ vpar_view(vpar_reroot(    [0, 1, 2, 3, 4, 5, 3, 7, 2, 9, 10, 11, 9, 13, 1, 15, 16, 17, 18], 3))
\\ n=19 domnum 7 count 31
\\ vpar_view(vpar_reroot(    [0, 1, 2, 3, 4, 5, 3, 7, 2, 9, 10, 11, 9, 13, 1, 15, 16, 17, 15], 2))
\\ n=19 domnum 7 count 34
\\ vpar_view(vpar_reroot(    [0, 1, 2, 3, 4, 5, 3, 7, 2, 9, 10, 1, 12, 13, 14, 15, 13, 1, 18], 2))
\\ n=19 domnum 7 count 28
\\ vpar_view(vpar_reroot(    [0, 1, 2, 3, 4, 5, 3, 7, 2, 9, 10, 1, 12, 13, 14, 15, 1, 17, 18], 2))
\\ n=19 domnum 7 count 30
\\ vpar_view(vpar_reroot(    [0, 1, 2, 3, 4, 5, 3, 7, 2, 9, 10, 1, 12, 13, 14, 12, 1, 17, 18], 2))
\\ n=19 domnum 7 count 22
\\ vpar_view(vpar_reroot(    [0, 1, 2, 3, 4, 2, 6, 7, 2, 9, 1, 11, 12, 13, 11, 15, 1, 17, 18], 1))
\\ n=19 domnum 7 count 20
\\ vpar_view(vpar_reroot(    [0, 1, 2, 3, 4, 2, 6, 1, 8, 9, 10, 8, 12, 1, 14, 15, 16, 14, 18], 1))   \\ Lowenstein's example
\\ n=19 domnum 7 count 28
\\ vpar_view(vpar_reroot(    [0, 1, 2, 3, 4, 2, 6, 1, 8, 9, 10, 8, 12, 1, 14, 15, 1, 17, 18], 1))


setintersect_sets(v) = my(s=v[1]); for(i=2,#v,s=setintersect(s,v[i])); s;

sets_any_disjoint_pair(v) =
{
  for(i=1,#v,
     for(j=i+1,#v,
        if(setintersect(v[i],v[j])==[],
           return(1))));  \\ a disjoint pair
  0;
}

{
  for(n=18,18,
     print("n="n);
     read(Str("/tmp/trees-"n".gp"));
     for(i=1,#lst,
        my(vpar=lst[i],
           sets=vpar_domnum_sets(vpar));
        if(#setintersect_sets(sets),next());     \\ a vertex common to all
        if(sets_any_disjoint_pair(sets),next()); \\ a disjoint pair
        
        print("n="n" domnum "#sets[1]" count "#sets);
        print("  "vpar);
        \\ for(i=1,#sets, print("  "sets[i]));
     );
  );
  quit;
}

        \\ for(i=1,#l,if(vpar_is_free_isomorphic(vpar,l[i]),next(2)));
        \\ listput(l,vpar);

\\------------------------------------------------------------------------------

\\ Christian Lowenstein, "In the Complement of a Dominating Set",
\\ dissertation, April 2010.
\\ https://www.db-thueringen.de/servlets/MCRFileNodeServlet/dbt_derivate_00021011/ilm1-2010000233.pdf
\\
\\             1
\\        /    |    \
\\     4      10      16
\\    / \     / \     / \  
\\   3   5   9  11  15  17 
\\   |   |   |   |   |   |
\\   2   6   8  12  14  18
\\       |       |       |
\\       7      13      19

vpar=vpar_reroot(vpar_make_path(6),3);
vpar=vpar_join(vpar_join(vpar_join([0],1,vpar),1,vpar),1,vpar);
\\ vpar_view(vpar);

vpar_minimal_domsets_count(vpar)
vpar_domnum_and_count(vpar) == [7, 20]

flags1 = [1, 0,1,0,0,1,0, 0,1,0,0,1,0, 0,1,0,0,1,0];
flags2 = [0, 1,0,1,0,0,1, 0,1,0,0,1,0, 0,1,0,0,1,0];
vpar_is_minimal_domset_flags(vpar,flags1)
vpar_is_minimal_domset_flags(vpar,flags2)
vecsum(flags1) == 7
vecsum(flags2) == 7

flags3 = [0, 1,0,1,0,0,1, 1,0,1,0,0,1, 1,0,1,0,0,1];
vpar_is_minimal_domset_flags(vpar,flags3)

test_flags_is_disjoint(flags1,flags2) = \
  for(i=1,min(#flags1,#flags2), if(flags1[i]&&flags2[i], return(0))); 1;
test_flags_is_disjoint(flags1,flags2)
test_flags_is_disjoint(flags1,flags3)

quit

