\\ Copyright 2017, 2018 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0);
default(strictargs,1);

option_verbose=0;

read("../vpar.gp");
read("../vpar-wip.gp");
read("../test-helpers.gp");


\\-----------------------------------------------------------------------------
\\ vpar_semitotdomnum() different from dom and totdom

\\ free trees
\\          n = 1  2  3  4  5  6  7  8
\\              0, 0, 0, 0, 0, 1, 1, 3, 7, 17, 48, 121, 317, 828, 2192, 5889,
\\ not in OEIS:                      3, 7, 17, 48, 121, 317, 828, 2192, 5889,

\\ n=5 path


\\ [0, 1, 2, 3, 1, 5]  2 3 4
\\
\\ n=6
\\ [0, 1, 2, 3, 1, 5, 5]  2 3 4
\\ *--*--*--*--*--*
\\    |
\\    *
\\
\\ n=7
\\ [0, 1, 2, 3, 3, 1, 6, 6]  2 3 4
\\ *--*--*--*--*--*
\\    |        |
\\    *        *
\\ [0, 1, 2, 3, 1, 5, 5, 5]  2 3 4
\\ *--*--*--*--*--*
\\  / |
\\ *  *
\\ [0, 1, 2, 3, 1, 5, 1, 7]  3 4 5
\\    *--*--*--*
\\  / |
\\ *  *
\\ |  |
\\ *  *
\\
{
  for(n=1,20,
     my(vpar=vpar_free_first(n),
         count=0);
     until((vpar=vpar_free_next(vpar))=='none,
           my(domnum=vpar_domnum(vpar),
              totdomnum=vpar_totdomnum(vpar),
              semitotdomnum=vpar_semitotdomnum(vpar));
           if(semitotdomnum != domnum
              && semitotdomnum != totdomnum,
              count++;
              if(n<=8, print(vpar"  "domnum" "semitotdomnum" "totdomnum));
             );
     \\ print1(count", ");
          ));
  quit;
}



\\-----------------------------------------------------------------------------
\\ vpar_semitotdomnum() quantities

\\ with_dom
\\ with_undom
\\ without_undom
\\ without_dom_child_dom
\\ without_dom_child_undom
\\ without_2dom


test_semitotdomnum_quant_initial = {[
  10^6,  \\ with_dom
  1,     \\ with_undom
  10^6,  \\ without_dom_child_dom
  10^6,  \\ without_dom_child_undom
  0      \\ without_undom
]};
test_semitotdomnum_quantities_add(p_quant,v_quant) =
{
  my(p_with_dom,
     p_with_undom,
     p_without_dom_child_dom,
     p_without_dom_child_undom,
     p_without_undom);
  [  p_with_dom,
     p_with_undom,
     p_without_dom_child_dom,
     p_without_dom_child_undom,
     p_without_undom ] = p_quant;

  my(v_with_dom,
     v_with_undom,
     v_without_dom_child_dom,
     v_without_dom_child_undom,
     v_without_undom);
  [  v_with_dom,
     v_with_undom,
     v_without_dom_child_dom,
     v_without_dom_child_undom,
     v_without_undom ] = v_quant;

  p_with_dom = min(min(p_with_dom,
                       p_with_undom)
                   + vecmin([v_with_dom,
                             v_with_undom,
                             v_without_dom_child_dom,
                             v_without_dom_child_undom]),
                   p_with_dom + v_without_undom);

  \\ sum(v_without_undom)
  p_with_undom = p_with_undom + v_without_undom;

  p_without_dom_child_dom
  = vecmin([p_without_dom_child_dom + vecmin([v_with_dom,
                                              v_with_undom,
                                              v_without_dom_child_dom]),
            p_without_dom_child_undom + min(v_with_dom,
                                            v_with_undom),
            p_without_undom + v_with_dom]);

  p_without_dom_child_undom
  = min(p_without_dom_child_undom + v_without_dom_child_dom,
        p_without_undom + v_with_undom);

  p_without_undom += v_without_dom_child_dom;

  my(q =
  [  p_with_dom,
     p_with_undom,
     p_without_dom_child_dom,
     p_without_dom_child_undom,
     p_without_undom ]);
  for(i=1,#q, q[i] = min(q[i], 10^6));
  q;
}

test_semitotdomnum_quantities_ret_list(quant) =
{
  my(v_with_dom,
     v_with_undom,
     v_without_dom_child_dom,
     v_without_dom_child_undom,
     v_without_undom);
  [  v_with_dom,
     v_with_undom,
     v_without_dom_child_dom,
     v_without_dom_child_undom,
     v_without_undom ] = quant;

  [ v_with_dom,
   v_without_dom_child_dom,
   v_without_dom_child_undom + 1 ];
}
test_semitotdomnum_quantities_ret(quant) =
{
  my(vec=test_semitotdomnum_quantities_ret_list(quant));
  my(d = vecmin(vec));
  if(d >= 10^6, -1, d);
}

test_semitotdomnum_by_quantities(vpar) =
{
  \\ print("test_semitotdomnum_by_quantities "vpar);
  my(seq=vpar_INTERNAL_seq_upwards(vpar),
     quant = vector(#vpar,v, test_semitotdomnum_quant_initial),
     ret = 0);
  for(i=1,#seq,
     my(v=seq[i], p=vpar[v]);
     \\ print(" v="v" "quant[v]);
     if(p,
        quant[p] = test_semitotdomnum_quantities_add(quant[p],quant[v]);
        ,
        my(d = test_semitotdomnum_quantities_ret(quant[v]));
        if(d==-1, return(-1));
        ret += d));
  ret;
}

{
  for(i=1,#test_sample_forests,
     my(vpar=test_sample_forests[i]);
     check_equal(vpar_semitotdomnum(vpar),
                 test_semitotdomnum_by_quantities(vpar),
     "test_semitotdomnum_by_quantities() vs test_semitotdomnum_by_separate()");
  );
}

test_semitotdomnum_quantities_add_and_inc(p_quant,v_quant) =
{
  my(q = test_semitotdomnum_quantities_add(p_quant,v_quant),
     m = 10^6);
  for(i=1,#q, m=min(m,q[i]));
  for(i=1,#q, if(q[i]<10^6, q[i]-=m));

  \\ cap quantities
  \\ for(i=1,#q, if(q[i]!=10^6, q[i]=min(q[i],6)));

  [ q, m ];
}

test_semitotdomnum_quant_list = List([]);
listput(test_semitotdomnum_quant_list, test_semitotdomnum_quant_initial);
\\ {
\\   \\ path-2
\\   listput(test_semitotdomnum_quant_list, [1, 0, 10^6, 0, 10^6]);
\\ }
\\ {
\\   \\ path-3
\\   listput(test_semitotdomnum_quant_list, [1, 10^6, 1, 0, 10^6]);
\\ }
\\ {
\\   \\ path-4
\\   listput(test_semitotdomnum_quant_list, [0, 1000000, 0, 1000000, 0]);
\\ }
\\ {
\\   \\ path-5
\\   listput(test_semitotdomnum_quant_list, [1, 1, 0, 1000000, 0]);
\\ }
\\ {
\\   \\ path-6
\\   listput(test_semitotdomnum_quant_list, [1, 1, 1, 1, 0]);
\\ }
\\ {
\\   \\ path-7
\\   listput(test_semitotdomnum_quant_list, [1, 0, 0, 0, 0]);
\\ }
\\ {
\\   \\ path-8
\\   listput(test_semitotdomnum_quant_list, [1, 1, 1, 0, 0]);
\\ }
\\ {
\\   \\ path-9
\\   listput(test_semitotdomnum_quant_list, [0, 0, 0, 0, 0]);
\\ }
\\ {
\\   \\ path-10
\\   listput(test_semitotdomnum_quant_list, [1, 1, 0, 0, 0]);
\\ }
\\ {
\\   \\ 11 = star-3
\\   listput(test_semitotdomnum_quant_list, [1, 0, 1, 1000000, 1000000]);
\\ }
\\ {
\\   \\ 12 = claw top
\\   listput(test_semitotdomnum_quant_list, [1, 1000000, 1, 0, 1]);
\\ }
\\ {
\\   \\ 13 = claw 2 above
\\   listput(test_semitotdomnum_quant_list, [0, 1, 0, 1000000, 0]);
\\ }
\\ {
\\   \\ 14 = claw 3 above
\\   listput(test_semitotdomnum_quant_list, [1, 1, 0, 1, 0]);
\\ }
\\ {
\\   \\ 15  p=2,v=2
\\   listput(test_semitotdomnum_quant_list, [0, 1000000, 0, 1000000, 1000000]);
\\ }
\\ {
\\   \\ 16  p=1,v=15
\\   listput(test_semitotdomnum_quant_list, [1, 1000000, 0, 1000000, 0]);
\\ }

test_semitotdomnum_quant_find(quant) =
{
  for(i=1,#test_semitotdomnum_quant_list,
     if(test_semitotdomnum_quant_list[i] == quant, return(i)));
  0;
}
{
  my(more=1);
  while(more && #test_semitotdomnum_quant_list<=200,
        more=0;
        for(p=1,#test_semitotdomnum_quant_list,
           for(v=1,#test_semitotdomnum_quant_list,
              my(quant=test_semitotdomnum_quantities_add_and_inc
                       (test_semitotdomnum_quant_list[p],
                        test_semitotdomnum_quant_list[v])[1],
                 f=test_semitotdomnum_quant_find(quant));
              if(f==0,
                 print("p="p" v="v" to "quant
                       " = "test_semitotdomnum_quantities_ret(quant));
                 listput(test_semitotdomnum_quant_list,quant);
                 more=1;
                 next(3)))));
  print("test_semitotdomnum_quant_list size "#test_semitotdomnum_quant_list);
}

{
  if(1,
     forstep(i=#test_semitotdomnum_quant_list,1,-1,
            my(quant=test_semitotdomnum_quant_list[i]);
            print("state="i"  ",quant));
     );
}
{
  if(1,
     for(p=1,#test_semitotdomnum_quant_list,
        print1("[");
        for(v=1,#test_semitotdomnum_quant_list,
           my(quant=test_semitotdomnum_quantities_add_and_inc
                    (test_semitotdomnum_quant_list[p],
                     test_semitotdomnum_quant_list[v])[1],
              f=test_semitotdomnum_quant_find(quant));
           printf("%2s,",if(f==0,"undef",f-1)));
        print("],"));

     print("accepting ret=1");
     print1("[");
     for(v=1,#test_semitotdomnum_quant_list,
        my(ret=test_semitotdomnum_quantities_ret
                 (test_semitotdomnum_quant_list[v]));
        if(ret, printf("%d,",v-1)));
     print("],");
    );
}

        \\ check_equal( != 0, 1,
        \\ "test_semitotdomnum_quant_list transitions")));
quit



\\-----------------------------------------------------------------------------
\\ vpar_semitotdomnum() state table
\\ WRONG

\\ present     = v in set
\\ dominated   = v dominated
\\ child_present_undom
\\ child_present_dom
\\ child_absent
test_semitotdomnum_rel_initial = [0, 0, 0, 0, 0];

test_semitotdomnum_rel_validate(rel) =
{
  \\ print("test_semitotdomnum_rel_validate() "rel);
  #rel==5 || error("test_semitotdomnum_rel_validate() short ",rel);
  my(present,dominated,child_present_undom,child_present_dom,child_absent);
    [present,dominated,child_present_undom,child_present_dom,child_absent] = rel;

  if(child_present_dom && child_present_undom,
     error("both child_present_dom and child_present_undom"));
  if(present && child_present_undom,
     error("both present and child_present_undom"));
  if(!dominated && (child_present_dom || child_present_undom),
     error("both !dominated and child_present"));
}
test_semitotdomnum_rel_validate(test_semitotdomnum_rel_initial);

\\ Return a vector [ new_rel, increment ] which is the new rel for p_rel
\\ accumulating v_rel under it, and increment = 0 or 1 to add to semitotdomnum.
\\
test_semitotdomnum_rel_add_and_inc(p_rel,v_rel) =
{
  \\ print("test_semitotdomnum_rel_add() p="p_rel"  v="v_rel);

  test_semitotdomnum_rel_validate(p_rel);
  test_semitotdomnum_rel_validate(v_rel);

  my(p_present,p_dominated,p_child_present_undom,p_child_present_dom,p_child_absent);
    [p_present,p_dominated,p_child_present_undom,p_child_present_dom,p_child_absent] = p_rel;
  my(v_present,v_dominated,v_child_present_undom,v_child_present_dom,v_child_absent);
    [v_present,v_dominated,v_child_present_undom,v_child_present_dom,v_child_absent] = v_rel;
  my(new_inc=0);

  \\ Must take parent to dominate absent child,
  \\ or to dominate v_child_present_undom.
  if(!p_present && !v_present && (!v_dominated || v_child_present_undom),
     new_inc++;
     p_present = 1);

  \\ v dominates p, or v child_present dominates p_present
  if(v_present, p_dominated = 1);
  if((v_child_present_dom || v_child_present_undom) && p_present,
     p_dominated = 1);

  \\ v present dominates other child of p
  if(v_present && (p_child_present_undom || p_child_present_dom),
     p_child_present_dom = 1;
     p_child_present_undom = 0);

  \\ v becomes child of p
  if(v_present &&  v_dominated, p_child_present_dom = 1,
     v_present && !v_dominated, p_child_present_undom = 1,
     !v_present,                p_child_absent = 1);

  \\ p_present or p_child_present_dom dominates an otherwise undom child
  if((p_present || p_child_present_dom) && p_child_present_undom,
     p_child_present_dom = 1;
     p_child_present_undom = 0);

  [ [p_present,p_dominated,p_child_present_undom,p_child_present_dom,p_child_absent],
    new_inc ];
}
test_semitotdomnum_rel_add(p_rel,v_rel) = \
  test_semitotdomnum_rel_add_and_inc(p_rel,v_rel)[1];

\\ Return the increment 0 or 1 to add to semitotdomnum if reach state rel at the
\\ root of a tree.
\\ If rel is not already dominated then take a child to dominate it.
\\ If child_present_undom==0 then cannot dominate, and return -1.
\\
test_semitotdomnum_rel_top_inc(rel) =
{
  my(present,dominated,child_present_undom,child_present_dom,child_absent);
  [present,dominated,child_present_undom,child_present_dom,child_absent] = rel;
  my(new_inc = 0);

  \\ undominated needs an absent child to add,
  \\ if no such then is a singleton and no semi-total domination
  if(!dominated && !child_absent, return(-1));

  \\ take child to dominate v
  if(!dominated, new_inc++);

  \\ take parent to dominate an undom child
  if(child_present_undom,  new_inc++);

  new_inc;
}

\\ rel of states
test_semitotdomnum_rel_list = List([]);
{
  \\ 1 = singleton
  listput(test_semitotdomnum_rel_list, test_semitotdomnum_rel_initial);

  check_equal(test_semitotdomnum_rel_top_inc
              (test_semitotdomnum_rel_list[1]), -1);
}
{
  \\   @       2 = path-2     present
  \\   |                      child_absent
  \\   *
  listput(test_semitotdomnum_rel_list, [1, 0, 0, 0, 1]);

  check_equal(test_semitotdomnum_rel_top_inc
              (test_semitotdomnum_rel_list[2]), 1,
              "test_semitotdomnum_rel_top_inc 2 = path-2");
}
{
  \\   *       3 = path-3     not present
  \\   |                      dominated
  \\   @                      child_present_undom
  \\   |
  \\   *
  listput(test_semitotdomnum_rel_list, [0, 1, 1, 0, 0]);

  check_equal(test_semitotdomnum_rel_add
              (test_semitotdomnum_rel_list[1],
               test_semitotdomnum_rel_list[2]),
              test_semitotdomnum_rel_list[3]);

  check_equal(test_semitotdomnum_rel_top_inc
              (test_semitotdomnum_rel_list[3]), 1,
              "test_semitotdomnum_rel_top_inc 3 = path-2");
}
{
  \\   @       4 = path-4     present
  \\   |                      dominated
  \\   *                      child_absent
  \\   |
  \\   @
  \\   |
  \\   *
  listput(test_semitotdomnum_rel_list, [1, 1, 0, 0, 1]);

  check_equal(test_semitotdomnum_rel_add
              (test_semitotdomnum_rel_list[1],
               test_semitotdomnum_rel_list[3]),
              test_semitotdomnum_rel_list[4]);

  check_equal(test_semitotdomnum_rel_top_inc
              (test_semitotdomnum_rel_list[4]), 0,
              "test_semitotdomnum_rel_top_inc 4 = path-4");
}
{
  \\     @      5 = path-4 root at second   p=3,v=1
  \\    / \            present, dominated
  \\   @   *           child_present_dom
  \\   |               child_absent
  \\   *
  listput(test_semitotdomnum_rel_list, [1, 1, 0, 1, 1]);

  check_equal(test_semitotdomnum_rel_add
              (test_semitotdomnum_rel_list[2],
               test_semitotdomnum_rel_list[2]),
              test_semitotdomnum_rel_list[5]);
  check_equal(test_semitotdomnum_rel_add
              (test_semitotdomnum_rel_list[3],
               test_semitotdomnum_rel_list[1]),
              test_semitotdomnum_rel_list[5]);

  check_equal(test_semitotdomnum_rel_top_inc
              (test_semitotdomnum_rel_list[5]), 0,
              "test_semitotdomnum_rel_top_inc 5");
}
{
  \\     *      6 = path-5 root at middle   path-5 root at end is same
  \\    / \          not present
  \\   @   @         dominated
  \\   |   |         child_present_dom
  \\   *   *
  listput(test_semitotdomnum_rel_list, [0, 1, 0, 1, 0]);

  check_equal(test_semitotdomnum_rel_add
              (test_semitotdomnum_rel_list[3],
               test_semitotdomnum_rel_list[2]),
              test_semitotdomnum_rel_list[6]);

  check_equal(test_semitotdomnum_rel_top_inc
              (test_semitotdomnum_rel_list[6]), 0,
              "test_semitotdomnum_rel_top_inc 6");
}
{
  \\     *
  \\     |           7 = another above      and path-6 end same
  \\     *                not present
  \\    / \               not dominated
  \\   @   @              child_absent
  \\   |   |
  \\   *   *        * -- *---@---*---@---*
  \\
  listput(test_semitotdomnum_rel_list, [0, 0, 0, 0, 1]);

  check_equal(test_semitotdomnum_rel_add
              (test_semitotdomnum_rel_list[1],
               test_semitotdomnum_rel_list[6]),
              test_semitotdomnum_rel_list[7]);

  check_equal(test_semitotdomnum_rel_top_inc
              (test_semitotdomnum_rel_list[7]), 1,
              "test_semitotdomnum_rel_top_inc 7");
}
{
  \\     *          8     p=3,v=6
  \\   /   \
  \\  @     *         not present
  \\  |    / \        dominated
  \\  *   @   @       child_present_undom
  \\      |   |       child_absent
  \\      *   *
  listput(test_semitotdomnum_rel_list, [0, 1, 1, 0, 1]);

  check_equal(test_semitotdomnum_rel_add
              (test_semitotdomnum_rel_list[3],
               test_semitotdomnum_rel_list[6]),
              test_semitotdomnum_rel_list[8]);

  check_equal(test_semitotdomnum_rel_top_inc
              (test_semitotdomnum_rel_list[8]), 1,
              "test_semitotdomnum_rel_top_inc 8");
}
{
  \\     *          9     p=6,v=6
  \\   / |  \
  \\  @  @    *         not present
  \\  |  |   / \        dominated
  \\  *  *  @   @       child_present_dom
  \\        |   |       child_absent
  \\        *   *
  listput(test_semitotdomnum_rel_list, [0, 1, 0, 1, 1]);

  check_equal(test_semitotdomnum_rel_add
              (test_semitotdomnum_rel_list[6],
               test_semitotdomnum_rel_list[6]),
              test_semitotdomnum_rel_list[9]);

  check_equal(test_semitotdomnum_rel_top_inc
              (test_semitotdomnum_rel_list[9]), 0,
              "test_semitotdomnum_rel_top_inc 9");
}

{
  if(1,
     forstep(i=#test_semitotdomnum_rel_list,1,-1,
            my(rel=test_semitotdomnum_rel_list[i]);
            print("state="i"  ",rel));
     );
}
for(i=1,#test_semitotdomnum_rel_list, \
  test_semitotdomnum_rel_validate(test_semitotdomnum_rel_list[i]));


\\ Return the state number 1 to 9 for the given rel, or return 0 if not one
\\ of the 9 states in test_equimatchable_rel_list.
test_semitotdomnum_rel_find(rel) =
{
  for(i=1,#test_semitotdomnum_rel_list,
     if(test_semitotdomnum_rel_list[i] == rel, return(i)));
  0;
}

{
  for(p=1,#test_semitotdomnum_rel_list,
     for(v=1,#test_semitotdomnum_rel_list,
        my(rel=test_semitotdomnum_rel_add
               (test_semitotdomnum_rel_list[p],
                test_semitotdomnum_rel_list[v]));
        print("p="p" v="v" to "rel);
        check_equal(test_semitotdomnum_rel_find(rel) != 0, 1,
        "test_semitotdomnum_rel_list transitions")));
}

{
  my(l=List([]));
  for(p=1,#test_semitotdomnum_rel_list,
     for(v=1,#test_semitotdomnum_rel_list,
        my(rel_and_inc=test_semitotdomnum_rel_add_and_inc
                       (test_semitotdomnum_rel_list[p],
                        test_semitotdomnum_rel_list[v]),
           new_rel = rel_and_inc[1],
           new_inc = rel_and_inc[2],
           new_state = test_semitotdomnum_rel_find(new_rel));
        if(! new_state,
           error("oops, no state for p=",p," v=",v));
        new_inc<=1 || error();
        listput(l, 2*(new_state-1) + new_inc)));

  if(1,
     for(p=1,#test_semitotdomnum_rel_list,
        print1(" ");
        for(v=1,#test_semitotdomnum_rel_list,
           printf("%2s%s",l[#test_semitotdomnum_rel_list*p + v
                            - #test_semitotdomnum_rel_list],
                 if(p==#test_semitotdomnum_rel_list
                       && v==#test_semitotdomnum_rel_list,
                   "", ",")));
        print()));

  check_equal(vpar_INTERNAL_semitotdomnum_table, Vecsmall(l));
}


\\ (test_semitotdomnum_rel_list[3])
\\ test_semitotdomnum_rel_top_inc(test_semitotdomnum_rel_list[3])

{
  if(1,
     print("top inc "vector(#test_semitotdomnum_rel_list,i,
                            test_semitotdomnum_rel_top_inc
                            (test_semitotdomnum_rel_list[i]))));
}

\\ {
\\   check_equal(apply(t->t%2, Vec(vpar_INTERNAL_semitotdomnum_table)),
\\               [1, 0, 1, 0, 0, 1, 1, 0,
\\                0, 0, 0, 0, 0, 0, 0, 0,
\\                1, 0, 1, 0, 0, 1, 1, 0,
\\                0, 0, 0, 0, 0, 0, 0, 0,
\\                1, 0, 1, 0, 0, 1, 1, 0,
\\                1, 0, 1, 0, 0, 1, 1, 0,
\\                1, 0, 1, 0, 0, 1, 1, 0,
\\                1, 0, 1, 0, 0, 1, 1, 0],
\\               "vpar_INTERNAL_semitotdomnum_table increments");
\\ }
\\ {
\\   check_equal(apply(t->t\2, Vec(vpar_INTERNAL_semitotdomnum_table)),
\\               [1, 2, 1, 2, 5, 1, 1, 5,
\\                1, 3, 1, 3, 1, 1, 1, 1,
\\                3, 4, 3, 4, 6, 3, 3, 6,
\\                3, 3, 3, 3, 3, 3, 3, 3,
\\                3, 4, 3, 4, 7, 3, 3, 7,
\\                1, 6, 1, 6, 5, 1, 1, 5,
\\                3, 7, 3, 7, 6, 3, 3, 6,
\\                3, 7, 3, 7, 7, 3, 3, 7],
\\               "vpar_INTERNAL_semitotdomnum_table states");
\\ }

\\ Return the semitotdomnum state 1 to 5 at the root of vpar.
\\ vpar must be a tree, not a forest.
\\
test_semitotdomnum_get_state(vpar) =
{
  my(seq=vpar_INTERNAL_seq_upwards(vpar),
     state = vectorsmall(#vpar));
  for(i=1,#seq,
     my(v=seq[i], p=vpar[v]);
     if(p,
        state[p] = vpar_INTERNAL_semitotdomnum_table[9*state[p]+state[v]+1] >> 1,
        return(state[v]+1)));
  0;
}
check_equal(test_semitotdomnum_get_state(vpar_make_path(1)), 1, \
           "test_semitotdomnum_get_state() singleton");
check_equal(test_semitotdomnum_get_state(vpar_make_path(2)), 2);
check_equal(test_semitotdomnum_get_state(vpar_make_path(3)), 3);
check_equal(test_semitotdomnum_get_state(vpar_make_path(4)), 4);
check_equal(test_semitotdomnum_get_state(vpar_make_path(5)), 6);
check_equal(test_semitotdomnum_get_state(vpar_make_path(6)), 7);
{
  \\ 5 = path-4 root at second
  check_equal(test_semitotdomnum_get_state([0,1,1,3]), 5,
              "test_semitotdomnum_get_state() path-4 root at second");
}

{
  \\ path-5 at end is same as path-5 at middle
  \\     *
  \\     |      not present
  \\     @      dominated
  \\     |      child_present_dom
  \\     *
  \\     |      no more at top
  \\     @
  \\     |
  \\     *
  check_equal(test_semitotdomnum_rel_add
              (test_semitotdomnum_rel_list[1],
               test_semitotdomnum_rel_list[4]),
              test_semitotdomnum_rel_list[6],
              "test_semitotdomnum_rel_add path-5");
  check_equal(test_semitotdomnum_rel_list[6], [0, 1, 0, 1, 0]);
  check_equal(test_semitotdomnum_rel_top_inc
              (test_semitotdomnum_rel_list[6]), 0,
              "test_semitotdomnum_rel_top_inc 6");
}

\\ {
\\   \\ p=1 v=7    path-7
\\   \\  * -- *---*---@---*---@---*
\\   \\
\\   \\ choice of take p as undom, or take v as dom
\\   \\
\\   \\
\\   check_equal(test_semitotdomnum_rel_add
\\               (test_semitotdomnum_rel_list[1],
\\                test_semitotdomnum_rel_list[7]),
\\               [1, 0, 0, 0, 1],
\\               "test_semitotdomnum_rel_add p=1,v=7");
\\   check_equal(test_semitotdomnum_rel_list[6], [1, 0, 0, 0, 1]);
\\
\\   \\ p=2 v=5
\\   check_equal(test_semitotdomnum_rel_add
\\               (test_semitotdomnum_rel_list[2],
\\                test_semitotdomnum_rel_list[5]),
\\               test_semitotdomnum_rel_list[5],
\\               "test_semitotdomnum_rel_add p=2,v=5");
\\
\\   check_equal(test_semitotdomnum_rel_top_inc
\\               (test_semitotdomnum_rel_list[5]), 0,
\\               "test_semitotdomnum_rel_top_inc 5");
\\ }


\\ {
\\   \\  *           *           *
\\   \\  6 <-- 4 <-- 1 <-- 3 <-- 5 <-- 2
\\   \\   \-- 7
\\   my(vpar=[4, 5, 1, 6, 3, 0, 6]);
\\   check_equal(test_semitotdomnum_and_count_by_flags(vpar_make_path(7)), [3,1]);
\\   check_equal(vpar_semitotdomnum(vpar_make_path(7)), 3,
\\               "vpar_semitotdomnum() path-7");
\\
\\   check_equal(test_semitotdomnum_and_count_by_flags(vpar), [3,1]);
\\   check_equal(vpar_semitotdomnum(vpar), 3);
\\ }
{
  for(i=1,#test_sample_forests,
     my(vpar=test_sample_forests[i],
        got=test_semitotdomnum_by_separate(vpar));
     #vpar <= test_limit_sets || next();
     check_equal(got,
                 test_semitotdomnum_and_count_by_flags(vpar)[1],
                 "test_semitotdomnum_by_separate() vs test_semitotdomnum_and_count_by_flags()");
  );
}
