\\ Copyright 2017, 2018, 2019, 2020, 2021 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0)
default(strictargs,1)
default(parisizemax,300*10^6);
read("../vpar.gp");
read("../vpar-wip.gp");
read("../test-helpers.gp");
read("memoize.gp");
\\ GP-DEFINE  read("../vpar.gp");
\\ GP-DEFINE  read("../vpar-wip.gp");

option_verbose=1;
progress_prev=-1;
progress(str) =


\\------------------------------------------------------------------------------
\\ Terminal Wiener Index Maximum

a_formula(n) =
{
  my(s=n\3);
  if(n%3==0, s^3 + 3*s^2 + s - 1,
     n%3==1, s^3 + 4*s^2 + 3*s,
     n%3==2, s^3 + 5*s^2 + 6*s + 2);
}

a(n) =
{
  my(s=n\3);
  if(n==2,1,
     n<=9, (n-1)*(n-2),
     n%3==0, s^3 + 3*s^2 + s - 1,
     n%3==1, s^3 + 4*s^2 + 3*s,
     n%3==2, s^3 + 5*s^2 + 6*s + 2);
}
recurrence_guess(vector(100,n,n--;a_formula(n)))
ga_formula(x) = (-1 + 2*x + x^2 + 2*x^3 - 2*x^4) / ((1-x)^4*(1+x+x^2)^2);

ga_formula(x) +O(x^20) - sum(n=0,20,a(n)*x^n)

\\ denom
\\ (1 - 2*x + x^2 - 2*x^3 + 4*x^4 - 2*x^5 + x^6 - 2*x^7 + x^8)

reps(n) =
{
  my(s=n\3);
  if(n<=9, 1,
     n%3==0, 1,
     n%3==1, ceil(s/2),
     n%3==2, ceil((s-1)/2));
}
reps_formula(n) =
{
  my(s=n\3);
  if(n%3==0, 1,
     n%3==1, ceil(s/2),
     n%3==2, ceil((s-1)/2));
}

vector(18,n,a_formula(n))
vector(18,n,a(n))
vector(18,n,reps_formula(n))
vector(50,n,reps(n))

A004526(n) = floor(n/2);
A133188(n) =
{
  n+=2;
  my(s=n\3,r=n%3);
  if(A004526(s-1)==0, [A004526(s-1), A004526(s), 1][r+1],
                      [1, A004526(s), A004526(s-1)][r+1]);
}
print();
vector(50,n, A133188(n+1)) - \
vector(50,n, reps(n))
{
  my(want=OEIS_samples("A133188")); \\ OFFSET=1
  check_equal(vector(#want,n, A133188(n)), want,
              "A133188()");
}
quit

{
\\ [0, 1, 2, 6, 12, 20, 30, 42, 56, 72, 92, 115, 140, 170, 204, 240, 282, 329]
\\ [1, 1, 2, 2, 2, 2, 2, 2, 2, 4, 4, 2, 7, 9, 3, 12, 13, 3]

  my(TW=vector(18),
     reps=TW);
  for(n=1,#TW,
     my(vpar=vpar_free_first(n));
     while((vpar=vpar_free_next(vpar))!='none,
           my(tw=vpar_Wiener_index(vpar,1));
           if(tw==TW[n], reps[n]++,
              tw>TW[n], TW[n]=tw;reps[n]=1)));
  print(TW);
  print(reps);
  quit;
}

